_wsprintf                       Proto C : LPTSTR , : LPCTSTR, : VARARG

.code
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Custom wsprintf. Written by BIGBOSS / COPS                            =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Supports: - %??d for decimal value.      (up to 16 displayed numbers) =
;   =           - %s   for string display.                                  =
;   =           - %??X for hexadecimal value.  (up to 16 displayed numbers) =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
_wsprintf                       Proc C  uses ebx ecx edx esi edi lpOut : LPTSTR, lpFmt : LPCTSTR , args : VARARG
 local          szHexa[010h] : BYTE
  xor                       eax, eax
  mov                       edi, lpOut
  mov                       esi, lpFmt
  lea                       ebx, args
  .While                  TRUE
   lodsb
   .If                    al == '%'
    xor                     ecx, ecx
    lodsb
    .While                (al >= '0' && al <= '9')
     imul                   ecx, 00Ah
     sub                    al, 030h
     add                    ecx, eax
     lodsb
    .EndW
     .If                  ecx > sizeof szHexa
      mov                   ecx, sizeof szHexa
     .EndIf
    .If                   al == 's'                                            ; String display
     call                   @string
    .ElseIf               al == 'X'                                            ; Hexadecimal display
     call                   @hexadecimal
    .ElseIf               al == 'd'                                            ; Decimal display
     call                   @decimal
    .EndIf
   .Else
    stosb
    .Break .If            al == 000h
   .EndIf
  .EndW
  mov                       eax, edi
  sub                       eax, lpOut
  ret
 @decimal:
  push                      esi
  push                      edi
  push                      ecx
  push                      ebx
  mov                       eax, [ebx]
  mov                       ebx, 00Ah
  mov                       ecx, sizeof szHexa
  lea                       edi, szHexa[000h + ecx - 001h]
  .Repeat
   xor                      edx, edx
   div                      ebx
   add                      dl, 030h
   mov                      [edi], dl
   dec                      edi
  .UntilCXZ
  pop                       ebx
  pop                       ecx
  pop                       edi
  lea                       esi, szHexa[sizeof szHexa]
  push                      edx
  mov                       edx, sizeof szHexa
  neg                       edx
  .While                  TRUE
   mov                      al, [esi + edx]
   .Break .If             al != '0'
   inc                      edx
  .EndW
  neg                       edx
  .If                     edx > ecx
   mov                      ecx, edx
  .EndIf
  pop                       edx
  sub                       esi, ecx
  rep                       movsb
  pop                       esi
  add                       ebx, 004h
  retn
 @hexadecimal:
  push                      esi
  push                      edi
  push                      ecx
  mov                       eax, [ebx]
  mov                       ecx, 010h
  lea                       edi, szHexa[sizeof szHexa - 001h]
  .Repeat
   push                     eax
   and                      eax, 00Fh
   .If                    al < 00Ah
    add                     al, 030h
   .Else
    add                     al, 037h
   .EndIf
   mov                      [edi], al
   dec                      edi
   pop                      eax
   shr                      eax, 004h
  .UntilCXZ
  pop                       ecx
  pop                       edi
  lea                       esi, szHexa[sizeof szHexa]
  push                      edx
  mov                       edx, sizeof szHexa
  neg                       edx
  .While                  TRUE
   mov                      al, [esi + edx]
   .Break .If             al != '0'
   inc                      edx
  .EndW
  neg                       edx
  .If                     edx > ecx
   mov                      ecx, edx
  .EndIf
  pop                       edx
  sub                       esi, ecx
  rep                       movsb
  pop                       esi
  add                       ebx, 004h
  retn
 @string:
  push                      esi
  mov                       esi, [ebx]
  .While                  TRUE
   lodsb
   .Break .If             al == 000h
   stosb
  .EndW
  pop                       esi
  add                       ebx, 004h
  retn
_wsprintf                       EndP
